#ifndef lint
static char *rcsid = "$Header: /a/pluto/vol/fileservers/Pluto/Pluto2/src/X500/xd/work/src/query_engine/RCS/sequence.c,v 1.0 92/11/27 16:58:17 emsrdsm Exp Locker: emsrdsm $";
#endif

/* $Header: /a/pluto/vol/fileservers/Pluto/Pluto2/src/X500/xd/work/src/query_engine/RCS/sequence.c,v 1.0 92/11/27 16:58:17 emsrdsm Exp Locker: emsrdsm $ */

/*****************************************************************************

  sequence.c - Linked list for string storage.

*****************************************************************************/

#include "util.h"
#include "sequence.h"

/*****************************************************************************
 * add_string_to_seq()
 *
 * 
 *
 ****************************************************************************/

void add_string_to_seq(string, sequence)
     char *string;
     stringCell *sequence;
{
  stringCell head = cell_alloc();
  head->string = copy_string(string);
  head->next = *sequence;
  *sequence = head;
} /* add_string_to_seq */

/*****************************************************************************
 * copy_string_seq()
 *
 * 
 *
 ****************************************************************************/

stringCell copy_string_seq(sequence)
     register stringCell sequence;
{
  register stringCell curr;
  stringCell head;

  if (sequence == NULLStrCell)
    return NULLStrCell;

  if (sequence != NULLStrCell)
    head = curr = cell_alloc();
  else
    return NULLStrCell;

  curr->next = NULLStrCell;
  curr->string = copy_string(sequence->string);

  sequence = sequence->next;

  while (sequence != NULLStrCell)
    {
      curr = curr->next = cell_alloc();

      curr->next = NULLStrCell;
      curr->string = copy_string(sequence->string);

      sequence = sequence->next;
    }

  return head;
} /* copy_string_seq */

/*****************************************************************************
 * delete_from_seq()
 *
 * 
 *
 ****************************************************************************/

void delete_from_seq(string, sequence)
     char *string;
     stringCell *sequence;
{
  stringCell curr_cell = *sequence;
  stringCell last_cell = NULLStrCell;

  while (curr_cell != NULLStrCell && strcmp(curr_cell->string, string) != 0)
    {
      last_cell = curr_cell;
      curr_cell = curr_cell->next;
    }

  if (curr_cell != NULLStrCell)
    {
      if (last_cell == NULLStrCell)
	*sequence = curr_cell->next;
      else
	last_cell->next = curr_cell->next;
      
      curr_cell->next = NULLStrCell;
      free_string_seq(&curr_cell);
    }
} /* delete_from_seq */


/*
 * - free_string_seq() -
 * Free a string sequence.
 *
 */
void free_string_seq(sequence)
     stringCell *sequence;
{
  register stringCell next_cell, curr_cell = *sequence;
  
  while (curr_cell != NULLStrCell)
    {
      free(curr_cell->string);
      next_cell = curr_cell->next;
      free((char *) curr_cell);
      curr_cell = next_cell;
    }

  *sequence = NULLStrCell;
} /* free_string_seq */

/*****************************************************************************
 * is_string_in_seq()
 *
 * 
 *
 ****************************************************************************/

QBool is_string_in_seq(str, str_list)
     char *str;
     stringCell str_list;
{
  register stringCell curr_str;

  for (curr_str = str_list; curr_str != NULLStrCell; curr_str = curr_str->next)
    if (lexequ(curr_str->string, str) == 0)
      return TRUE;

  return FALSE;
} /* is_string_in_seq */




