#ifndef _query_update_h_
#define _query_update_h_

#include "types.h"
#include "error.h"
#include "sequence.h"
#include "read.h"
#include "attrt_list.h"

#include "modify.h"
#include "add.h"
#include "delete.h"
#include "rename.h"

/***************************************************
 *
 * Update result structure.
 *
 */

typedef struct _update_result
{
  QBool was_successful;
  QBool modify_attempted;
  QBool modify_succeeded;
  QBool rename_attempted;
  QBool rename_succeeded;

  char *updated_object;
  
  errorList errors;
} update_result, *updateResult;

#define NULLUpdateResult (updateResult) NULL
#define update_result_alloc() (updateResult) smalloc(sizeof(update_result))

/***************************************************
 *
 * Update request record.
 *
 */

typedef struct _update_rec
{
  QCardinal request_id;
  QCardinal sub_request_id;

  char *baseobject;
  char *new_name;
  char *new_baseobject;

  updateResult result;
} update_rec, *updateRec;

#define NULLUpdateRec (updateRec) NULL
#define update_rec_alloc() (updateRec) smalloc(sizeof(update_rec))

/***************************************************
 *
 * Public procedures.
 *
 */

errorList do_update();
updateResult get_update_result();

request_state process_update_request_result();
void free_update_rec(), free_update_result();

#endif /* _query_update_h_ */
