#ifndef lint
static char *rcsid = "$Header: /a/pluto/vol/fileservers/Pluto/Pluto2/src/X500/xd/work/src/RCS/showlist.c,v 1.0 92/11/27 17:00:41 emsrdsm Exp Locker: emsrdsm $";
#endif

/* $Header: /a/pluto/vol/fileservers/Pluto/Pluto2/src/X500/xd/work/src/RCS/showlist.c,v 1.0 92/11/27 17:00:41 emsrdsm Exp Locker: emsrdsm $ */

/*****************************************************************************

  showlist.c - Display lists of directory entries

*****************************************************************************/

#include "defs.h"

#include <X11/Xatom.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Viewport.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/List.h>

#include "query.h"
#include "quipu/common.h"

#include "windows.h"
#include "objects.h"
#include "callbacks.h"
#include "configure.h"
#include "actions.h"
#include "y.tab.h"
#include "layout.h"
#include "xdutil.h"

#include "showlist.h"

/***************************************************
 *
 * Local functions.
 *
 */

static void updateEntryList();

/***************************************************
 *
 * Externals.
 *
 */

extern windowObject win_objects[];

/*****************************************************************************
 * displayCurrentList()
 *
 * 
 *
 ****************************************************************************/

void displayCurrentList(this_object_id)
     Cardinal this_object_id;
{
  Cardinal listsize;
  WidgetList prim_insts;
  windowObject this_object = win_objects[this_object_id];
  entryList currlist;

  for (currlist = this_object->current_list, listsize = 0;
       currlist != NULLEntryList;
       currlist = currlist->next, listsize++)
    ;

  prim_insts = findPrimitiveInstances(this_object_id, ENTRY_LIST);

  if (prim_insts != (Widget *) NULL)
    {
      updateEntryList(prim_insts[0],
		      this_object_id,
		      listsize,
		      this_object->current_list);
      
      XtFree((char *) prim_insts);
  }
} /* displayCurrentList */

/*****************************************************************************
 * updateEntryList()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
static void updateEntryList(widget, object_id, listsize, entrylist)
     Widget widget;
     Cardinal object_id;
     Cardinal listsize;
     entryList entrylist;
{
  Widget form, vscroll, hscroll;
  Cardinal count, oldcount, entrycount;
  Arg args[MAXARGS];
  entryList currentry, listcopy = NULLEntryList;
  char fname[LINESIZE];
  static String scrollback = "Backward",
                fullscroll = "FullLength";
  XEvent event;
  String *stringlist, *oldlist;

  stringlist = (String *) XtCalloc(listsize + 1, sizeof(String));

  /***************************************************
   *
   * Copy entry list.
   *
   */

  (void) dn_list_copy(entrylist, &listcopy);

  form = XtNameToWidget(widget, "listForm");

  for (entrycount = 0, currentry = listcopy;
       entrycount < listsize;
       entrycount++, currentry = currentry->next)
    {
      friendlify(currentry->string_dn, fname);
      stringlist[entrycount] = XtNewString(fname);
    }

  count = 0;
  XtSetArg(args[count], XtNlist, &oldlist); count++;
  XtSetArg(args[count], XtNnumberStrings, &oldcount); count++;
  XtGetValues(form, args, count);

  count = 0;
  XtSetArg(args[count], XtNnumberStrings, (int) listsize); count++;
  XtSetArg(args[count], XtNlist, stringlist); count++;
  XtSetValues(form, args, count);

  for (count = 0; oldlist[count] != NULLString && count < oldcount; count++)
    XtFree(oldlist[count]);

  XtFree((char *) oldlist);

  hscroll = XtNameToWidget(widget, "horizontal");
  vscroll = XtNameToWidget(widget, "vertical");

  event.type = ClientMessage;
  event.xclient.serial = 0;
  event.xclient.send_event = TRUE;
  event.xclient.display = XtDisplay(hscroll);
  event.xclient.window = XtWindow(hscroll);
  event.xclient.message_type = XA_CARDINAL;
  event.xclient.format = 32;

  XtCallActionProc(hscroll, "StartScroll", &event, &scrollback, 1);
  XtCallActionProc(hscroll, "NotifyScroll", &event, &fullscroll, 1);
  XtCallActionProc(hscroll, "EndScroll", &event, (String *) NULL, 0);

  event.xclient.window = XtWindow(vscroll);

  XtCallActionProc(vscroll, "StartScroll", &event, &scrollback, 1);
  XtCallActionProc(vscroll, "NotifyScroll", &event, &fullscroll, 1);
  XtCallActionProc(vscroll, "EndScroll", &event, (String *) NULL, 0);

  XFlush(XtDisplay(widget));
} /* updateEntryList */
