#ifndef lint
static char *rcsid = "$Header: /a/pluto/vol/fileservers/Pluto/Pluto2/src/X500/xd/work/src/RCS/update2.c,v 1.0 92/11/27 17:00:22 emsrdsm Exp Locker: emsrdsm $";
#endif

/* $Header: /a/pluto/vol/fileservers/Pluto/Pluto2/src/X500/xd/work/src/RCS/update2.c,v 1.0 92/11/27 17:00:22 emsrdsm Exp Locker: emsrdsm $ */

/*****************************************************************************

  update2.c - Modify operations (add, update, delete)

*****************************************************************************/

#include "defs.h"
#include <X11/Xatom.h>

#include <X11/Xaw/Form.h>
#include <X11/Xaw/Command.h>

#include <X11/Xaw/SimpleMenu.h>
#include <X11/Xaw/Sme.h>
#include <X11/Xaw/SmeBSB.h>
#include <X11/Xaw/SmeLine.h>
#include <X11/Xaw/MenuButton.h>

#include <X11/Xaw/Viewport.h>
#include <X11/Xaw/AsciiText.h>

#include "query.h"
#include "quipu/common.h"

#include "windows.h"
#include "requests.h"
#include "objects.h"
#include "callbacks.h"
#include "configure.h"
#include "actions.h"
#include "y.tab.h"
#include "layout.h"
#include "xdutil.h"
#include "xutil.h"

#include "update1.h"
#include "status.h"
#include "errview.h"

/***************************************************
 *
 * Externals.
 *
 */

extern windowObject win_objects[];
extern Display *dpy;
extern Widget toplevel;
extern XContext mod_status_cid, add_class_cid, context_id;

extern void updateFieldData();

/***************************************************
 *
 * Local functions.
 *
 */

static void submitUpdates();
static void addEntry();

static void gotAddResult();
static void gotNameCheckResult();
static void gotUpdateResult();
static void gotDeleteResult();

static modifyAttr getNewFieldValues();
static modifyAttr getUpdates();

/***************************************************
 *
 * Local storage.
 *
 */

static char err_msg[LINESIZE];

/***************************************************
 *
 * Global storage.
 *
 */

entryClass entry_class_list = NULLEntryClass;
attributeGroup attr_group_list = NULLAttrGroup;
attrOcRule attr_oc_list = NULLAttrOcRule;
attrTemplate attr_template_list = NULLAttrTemplate;
String base_entry_class = NULLString;

/*****************************************************************************
 * submitModificationsCallback()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
void submitModificationsCallback(w, closure, calldata)
     Widget w;
     XtPointer closure;
     XtPointer calldata;
{
  QCardinal object_id = get_object_id(w);
  Widget prim_widget = XtParent(w);
  
  Boolean changes;
  updateState state;

  getUpdateStatus(prim_widget, &changes, &state);

  switch (state)
    {
    case Modifying:

      submitUpdates(prim_widget, object_id);
      break;

    case Composing:

      addEntry(prim_widget, object_id);
      break;
    }

  doPrimitiveSensitivity(object_id);
} /* submitModificationsCallback */

/*****************************************************************************
 * submitUpdates()
 *
 * 
 *
 ****************************************************************************/

static void submitUpdates(modify, object_id)
     Widget modify;
     Cardinal object_id;
{
  modifyEntry mentry;
  modifyAttr updates;
  caddr_t data;
  windowObject object = win_objects[object_id];
  errorList errors;
  QCardinal request_id;

  /**************************************************
   *
   * Get a list of updated attributes.
   * 
   */

  (void) XFindContext(dpy, XtWindow(modify), context_id, &data);
  mentry = (modifyEntry) data;

  updates = getUpdates(mentry);
  if (updates == NULLModifyAttr)
    {
      XBell(dpy, 40);
      setStatusMessage(object_id, "No changes to make!");
      return;
    }

  errors = do_update(&request_id, object->current_entry, NULLString, updates);
  if (errors != NULLError)
    {
      errorList curr_error;
      
      XBell(dpy, 40);
      
      for (curr_error = errors;
           curr_error != NULLError;
           curr_error = curr_error->next)
        if (curr_error->error_type != QERR_no_mods_supplied &&
            curr_error->error_type != QERR_no_name_changes)
          break;

      if (curr_error != NULLError)
        {
          if (curr_error->ds_message != NULLCP)
            setStatusMessage(object_id, curr_error->ds_message);
          else
            setStatusMessage(object_id,
                             get_message_of_code(curr_error->error_type));

          set_current_errors(object_id, errors);
        }
      else
        {
          setStatusMessage(object_id, "No modifications to make!");
          error_list_free(&errors);
          set_current_errors(object_id, NULLError);
        }

      return;
    }

  /**************************************************
   *
   * Record request invocation.
   * 
   */

  request_invoked(request_id,
		  MODIFY_ENTRY,
		  gotUpdateResult,
		  (DSReportCallback) NULL,
		  modify,
		  object_id,
		  MODIFY,
		  0,
		  NULLTransList);

  XBell(dpy, 40);
  setStatusMessage(object_id, "Saving changes, please wait.");
} /* submitUpdates */

/*****************************************************************************
 * addEntry()
 *
 * 
 *
 ****************************************************************************/

static void addEntry(prim_widget, object_id)
     Widget prim_widget;
     Cardinal object_id;
{
  Cardinal count;
  Arg args[MAXARGS];
  entryClass class;
  modifyEntry mod_entry;
  modifyAttr mod_attr = NULLModifyAttr, curr_attr,
             top_attr = NULLModifyAttr, additions;
  modifyValue mod_value = NULLModifyValue, curr_value;

  QCardinal request_id;

  String entry_name;
  Widget name_field;
  errorList errors;

  caddr_t data;
  
  if (XFindContext(dpy, XtWindow(prim_widget), context_id, &data) == XCNOENT)
    return;

  mod_entry = (modifyEntry) data;

  if (XFindContext(dpy, XtWindow(prim_widget), add_class_cid, &data)== XCNOENT)
    return;

  class = (entryClass) data;

  /**************************************************
   *
   * Default attributes (those not displayed).
   * 
   */

  for (curr_attr = mod_entry->undisplayed;
       curr_attr != NULLModifyAttr;
       curr_attr = curr_attr->next)
    {
      mod_attr = modify_attr_alloc();
      
      mod_attr->to_modify = FALSE;
      mod_attr->attr_type = curr_attr->attr_type;
      
      mod_attr->next = top_attr;
      top_attr = mod_attr;

      for (curr_value = curr_attr->values, mod_attr->values = NULLModifyValue;
	   curr_value != NULLModifyValue;
	   curr_value = curr_value->next)
	{
	  mod_value = modify_value_alloc();

	  mod_value->next = mod_attr->values;
	  mod_attr->values = mod_value;

	  mod_value->value = XtNewString(curr_value->value);
	  mod_value->new_value = NULLString;

	  mod_value->status = curr_value->status;
	}
    }

  /**************************************************
   *
   * Get edited values.
   * 
   */

  for (curr_attr = top_attr;
       curr_attr->next != NULLModifyAttr;
       curr_attr = curr_attr->next)
    ;
     
  additions = getUpdates(mod_entry);

  if (curr_attr != NULLModifyAttr)
    {
      curr_attr->next = additions;
      additions = top_attr;
    }
  
/*
  for (mod_group = mod_entry->groups;
       mod_group != NULLModifyGroup;
       mod_group = mod_group->next)
    {
      mod_field = mod_group->fields;
      
      while (mod_field != NULLModifyField)
	{
	  last_value = mod_value = NULLModifyValue;

	  for (curr_attr = mod_field->this_attr, last_value = NULLModifyValue;
	       mod_field != NULLModifyField && mod_field->this_attr==curr_attr;
	       mod_field = mod_field->next)
	    {
	      String string_value;
	      Boolean free_field;

	      free_field = FALSE;

	      if (mod_field->this_value->status == deleted)
		continue;

	      curr_value = mod_field->this_value;

	      if (mod_field->changed == TRUE)
		{
		  if (mod_field->edit != NULLWidget)
		    {
		      String new_string_value;

		      XtSetArg(args[0], XtNstring, &new_string_value);
		      XtGetValues(mod_field->edit, args, 1);

		      while (isspace(*new_string_value) &&
			     !isnull(*new_string_value))
			new_string_value++;

		      string_value = new_string_value;
		      free_field = TRUE;
		    }
		  else
		    string_value = curr_value->new_value;
		}
	      else
		string_value = curr_value->value;

	      if (string_value == NULLString || isnull(*string_value))
		continue;

	      mod_value = modify_value_alloc();

	      mod_value->next = last_value;
	      last_value = mod_value;

	      mod_value->status = curr_value->status;

	      mod_value->value = XtNewString(string_value);
	      mod_value->new_value = NULLString;
	      
	      if (free_field == TRUE)
		XawAsciiSourceFreeString(mod_field->edit);
	    }

	  if (mod_value != NULLModifyValue)
	    {
	      mod_attr = modify_attr_alloc();
	      
	      mod_attr->to_modify = FALSE;
	      mod_attr->attr_type = mod_field->this_attr->attr_type;
	      
	      mod_attr->next = top_attr;
	      top_attr = mod_attr;

	      mod_attr->values = mod_value;
	      mod_value = NULLModifyValue;
	    }
	}
    }
*/

  /***************************************************
   *
   * Last (but not least) add the object class values
   * defined by the entry class.
   *
   */

 /***************************************************
   *
   * Get entry name.
   *
   */

  name_field = XtNameToWidget(prim_widget, "entryName");

  count = 0;
  XtSetArg(args[count], XtNstring, &entry_name); count++;
  XtGetValues(name_field, args, count);

  /***************************************************
   *
   * Initiate add request.
   *
   */

  errors = do_add(&request_id,
		  NULLString,
		  entry_name,
		  class->rdn_type,
		  additions);

  if (errors != NULLError)
    {
      XBell(dpy, 40);

      if (errors->ds_message != NULLString)
	setStatusMessage(object_id, errors->ds_message);
      else
	setStatusMessage(object_id, get_message_of_code(errors->error_type));
      
      set_current_errors(object_id, errors);
    }

  /***************************************************
   *
   * Record request invocation.
   *
   */
  
  request_invoked(request_id,
		  ADD_ENTRY,
		  gotAddResult,
		  (DSReportCallback) NULL,
		  prim_widget,
		  object_id,
		  MODIFY,
		  ActionUndefined,
		  NULLTransList);
} /* addEntry */

/*****************************************************************************
 * gotAddResult()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
static void gotAddResult(request_id, object_id, action_id, trans_list)
     QCardinal request_id;
     Cardinal object_id;
     actionID action_id;
     translationList trans_list;
{
  addResult result;
  WidgetList prim_insts;
  Widget name_edit;

  Arg args[MAXARGS];
  Cardinal count;

  caddr_t data;

  XBell(dpy, 40);

  result = get_add_result(request_id);

  if (result->was_successful == TRUE)
    {
      char new_name[LINESIZE];

      setStatusMessage(object_id, "Entry added succesfully");
      prim_insts = findPrimitiveInstances(object_id, MODIFY);

      (void) XFindContext(dpy, XtWindow(prim_insts[0]), context_id, &data);
      updateFieldData((modifyEntry) data);

      set_current_entry(object_id, result->baseobject);
      setUpdateStatus(prim_insts[0], TRUE, Modifying);

      friendlify(result->baseobject, new_name);
      name_edit = XtNameToWidget(prim_insts[0], "entryName");

      count = 0;
      XtSetArg(args[count], XtNstring, new_name); count++;
      XtSetValues(name_edit, args, count);

      XtFree((char *) prim_insts);
    }
  else
    {
      (void) sprintf(err_msg,
                     "Add operation failed because;\n%s",
                     get_message_of_code(result->errors->error_type));

      setStatusMessage(object_id, err_msg);
    }

  set_current_errors(object_id, result->errors);
  result->errors = NULLError;

  request_complete(request_id);
  free_add_result(&result);
} /* gotAddResult */

/*****************************************************************************
 * checkEntryName()
 *
 * 
 *
 ****************************************************************************/

void checkEntryName(name, object_id, primitive)
     String name;
     Cardinal object_id;
     Widget primitive;
{
  QE_error_code srch_state;
  Cardinal request_id;

  srch_state = do_ufn_resolve(NULLEntryList, name, unknown, &request_id);

  switch (srch_state)
    {
    case QERR_bad_value_syntax:

      XBell(dpy, 40);
      XLUmessage
	("The entry name supplied is invalid!\nCan't continue with addition.",
	 object_id);
      
      return;

    case QERR_internal_limit_reached:

      XBell(dpy, 40);
      XLUmessage("Internal limit reached, cannot search!", object_id);

      return;
    }

  setStatusMessage(object_id, "Validating parent entry name. Please wait.");

  request_invoked(request_id,
		  UFNAME,
		  gotNameCheckResult,
		  (DSReportCallback) NULL,
		  primitive,
		  object_id,
		  MODIFY,
		  ActionUndefined,
		  NULLTransList);
} /* checkEntryName */

/*****************************************************************************
 * gotNameCheckResult()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
static void gotNameCheckResult(request_id,
			       this_object_id,
			       action_id,
			       trans_list)
     Cardinal request_id;
     Cardinal this_object_id;
     actionID action_id;
     translationList trans_list;
{
  ufnResults results;
  errorList errors;
  Cardinal err_num;
  char strufn[LINESIZE], parent_strufn[LINESIZE], errmsg[LINESIZE];
  String rdn;
  entryClass class;
  WidgetList prim_insts;
  caddr_t data;

  extern XContext add_rdn_cid;
  extern Widget add_dialog;

  results = get_ufn_results(request_id);
  _request_complete(request_id);

  prim_insts = findPrimitiveInstances(this_object_id, MODIFY);
  if (prim_insts == (WidgetList) NULL)
    {
      ufname_result_free(&results);
      return;
    }

  if (XFindContext(dpy, XtWindow(prim_insts[0]), add_rdn_cid, &data)
      == XCNOENT)
    {
      ufname_result_free(&results);
      XtFree((char *) prim_insts);

      return;
    }

  XDeleteContext(dpy, XtWindow(prim_insts[0]), add_rdn_cid);
  rdn = (String) data;

  if (XFindContext(dpy, XtWindow(prim_insts[0]), add_class_cid, &data)
      == XCNOENT)
    {
      ufname_result_free(&results);
      XtFree((char *) prim_insts);
      XtFree(rdn);

      return;
    }

  class = (entryClass) data;

  /***************************************************
   *
   * Check the error situation.
   *
   */
  
  for (err_num = 0, errors = results->errors;
       errors != NULLError;
       errors = errors->next, err_num++)
    ;

  set_current_errors(this_object_id, results->errors);

  if (err_num > 0)
    updateErrorViewer(this_object_id);

  if (results->match_status == Failed)
    {
      /***************************************************
       *
       * Couldn't find a context.
       *
       */
      
      XBell(dpy, 40);
      
      (void) sprintf(errmsg,
 "Couldn't find parent entry!\nCan't continue with operation.",
		     results->unresolved_part);

      XLUmessage(errmsg, this_object_id);
      XtSetSensitive(XtNameToWidget(add_dialog, "addDialogForm"), TRUE);
      
      ufname_result_free(&results);
      XtFree(rdn);
      
      return;
    }

  if (results->match_num != 1)
    {
      /***************************************************
       *
       * Can't have more than one parent!
       *
       */

      XBell(dpy, 40);

      (void) sprintf(errmsg,
"Couldn't find a single match for parent name!\nCan't continue with operation.",
		      results->unresolved_part);

      XLUmessage(errmsg, this_object_id);
      XtSetSensitive(XtNameToWidget(add_dialog, "addDialogForm"), TRUE);

      XtFree(rdn);
      ufname_result_free(&results);

      return;
    }

  friendlify(results->matches->string_dn, parent_strufn);

  (void) strcpy(strufn, rdn);
  (void) strcat(strufn, ", ");
  (void) strcat(strufn, parent_strufn);

  XtFree(rdn);

  setStatusMessage(this_object_id, "Entry name OK.");
  displayClassTemplate(strufn, class, prim_insts[0], this_object_id);

  request_complete(request_id);
  ufname_result_free(&results);

  doPrimitiveSensitivity(this_object_id);
  setUpdateStatus(prim_insts[0], TRUE, Composing);

  XtFree((char *) prim_insts);

  /**************************************************
   *
   * Name checked OK, destroy dialog.
   * 
   */
  
  XtSetSensitive(XtNameToWidget(add_dialog, "addDialogForm"), TRUE);
  XtPopdown(XtParent(add_dialog));
  XtDestroyWidget(add_dialog);
} /* gotNameCheckResult */

/*****************************************************************************
 * gotUpdateResult()
 *
 *
 *
 *
 ****************************************************************************/

/* ARGSUSED */
static void gotUpdateResult(request_id, object_id, action_id, trans_list)
     QCardinal request_id;
     Cardinal object_id;
     actionID action_id;
     translationList trans_list;
{
  updateResult result;
  WidgetList prim_insts;
  caddr_t data;

  XBell(dpy, 40);

  result = get_update_result(request_id);

  if (result->was_successful == TRUE)
    {
      setStatusMessage(object_id, "Changes saved succesfully");
      prim_insts = findPrimitiveInstances(object_id, MODIFY);

      (void) XFindContext(dpy, XtWindow(prim_insts[0]), context_id, &data);
      updateFieldData((modifyEntry) data);

      XtFree((char *) prim_insts);
    }
  else
    {
      (void) sprintf(err_msg,
                     "Add operation failed because:\n%s",
                     get_message_of_code(result->errors->error_type));

      setStatusMessage(object_id, err_msg);
    }

  set_current_errors(object_id, result->errors);
  result->errors = NULLError;

  request_complete(request_id);
  free_update_result(&result);
} /* gotUpdateResult */

/*****************************************************************************
 * getNewFieldValues()
 *
 * Update the value contained in the given field
 *
 ****************************************************************************/

static modifyAttr getNewFieldValues(field)
     modifyField field;
{
  modifyAttr attr;
  modifyValue value;
  Arg args[MAXARGS];
  Cardinal count, changecount = 0;
  String strval, tidystr;
  Boolean haveNew, haveOld;

  attr = field->this_attr;
  attr->to_modify = FALSE;

  while (field != NULLModifyField)
    {
      value = field->this_value;

      if (field->changed == TRUE)
	{
	  /**************************************************
	   *
	   * Get updated value.
	   * 
	   */
	  
	  if (field->edit != NULLWidget)
	    {
	      count = 0;
	      XtSetArg(args[count], XtNstring, &strval); count++;
	      XtGetValues(field->edit, args, count);
	      
	      strval = XtNewString(strval);
	      tidystr = XtNewString(TidyString(strval));
	      
	      free(strval);
/* 	      XawAsciiSrcFreeString(field->edit); */

	      strval = tidystr;
	      if (isnull(*strval))
		{
		  free(strval);
		  strval = NULLString;
		}
	    }
	  else
	    strval = value->new_value;

	  value->new_value = strval;
	      
	  /**************************************************
	   *
	   * Set the value update flag.
	   * 
	   */

	  haveNew = (strval == NULLString? FALSE : TRUE);
	  haveOld = (value->value == NULLString? FALSE : TRUE);

	  if (haveOld == TRUE && haveNew == TRUE)
	    {
	      if (lexequ(value->new_value, value->value) == 0)
		{
		  /**************************************************
		   *
		   * New and old values are the same!
		   * 
		   */
		  {
		    XtFree(value->new_value);
		    value->new_value = NULLString;
		    value->status = unchanged;
		  }
		}
	      else
		{
		  changecount++;
		  value->status = updated;
		}
	    }
	  else if (haveOld == FALSE && haveNew == TRUE)
	    {
	      changecount++;
	      value->status = new;
	    }
	  else if (haveOld == TRUE && haveNew == FALSE)
	    {
	      changecount++;
	      value->status = deleted;
	    }
	  else
	    value->status = unchanged;
	}
      else
	/**************************************************
	 *
	 * No changes flagged.
	 * 
	 */
	{
	  value->status = unchanged;
	}

      field = field->next;
    }

  if (changecount > 0)
    {
      attr->to_modify = TRUE;
      return attr;
    }
  else
    return NULLModifyAttr;
} /* getNewFieldValues */

/*****************************************************************************
 * getUpdate()
 *
 * Get updates from a modifyEntry.
 *
 ****************************************************************************/

static modifyAttr getUpdates(mentry)
     modifyEntry mentry;
{
  modifyField field;
  modifyGroup group;
  modifyAttr first = NULLModifyAttr, last = NULLModifyAttr, attr;

  for (group = mentry->groups; group != NULLModifyGroup; group = group->next)
    {
      field = group->fields;
      while (field != NULLModifyField)
	{
	  modifyField attrfield, nextfield;

	  /**************************************************
	   *
	   * Get a list of fields containing values
	   * from the same attribute.
	   * 
	   */

	  for (attrfield = field, attr = field->this_attr;
	       attrfield->next != NULLModifyField &&
	       attrfield->next->this_attr == attr;
	       attrfield = attrfield->next)
	    ;

	  nextfield = attrfield->next;
	  attrfield->next = NULLModifyField;

	  /**************************************************
	   *
	   * Get updated field sequence (if any updates
	   * made).
	   */

	  attr = getNewFieldValues(field);
	  if (attr != NULLModifyAttr)
	    {
	      if (first == NULLModifyAttr)
		first = last = attr;
	      else
		{
		  last->next = attr;
		  last = attr;
		}
	    }

	  /* Loop advance */
	  field = attrfield->next = nextfield;
	}
    }

  return first;
} /* getUpdates */

/*****************************************************************************
 * deleteEntry()
 *
 * Delete an entry.
 *
 ****************************************************************************/

/* ARGSUSED */
void deleteEntry(w, closure, calldata)
     Widget w;
     XtPointer closure;
     XtPointer calldata;
{
  Cardinal object_id;
  windowObject object;
  WidgetList instances;
  errorList errors;
  Cardinal request_id;
  
  object_id = get_object_id(w);
  object = win_objects[object_id];

  instances = findPrimitiveInstances(object_id, MODIFY);

  /**************************************************
   *
   * Invoke delete operation.
   * 
   */

  errors = do_delete(&request_id, object->current_entry);
  if (errors != NULLError)
    {
      XBell(dpy, 40);

      if (errors->ds_message != NULLString)
	setStatusMessage(object_id, errors->ds_message);
      else
	setStatusMessage(object_id, get_message_of_code(errors->error_type));
      
      set_current_errors(object_id, errors);
    }

  /***************************************************
   *
   * Record request invocation.
   *
   */
  
  request_invoked(request_id,
		  DELETE_ENTRY,
		  gotDeleteResult,
		  (DSReportCallback) NULL,
		  instances[0],
		  object_id,
		  MODIFY,
		  ActionUndefined,
		  NULLTransList);

  XtFree((char *) instances);
} /* deleteEntry */

/*****************************************************************************
 * gotDeleteResult()
 *
 * Received a delete result/error.
 *
 ****************************************************************************/

/* ARGSUSED */
static void gotDeleteResult(request_id, object_id, action_id, trans_list)
     QCardinal request_id;
     Cardinal object_id;
     actionID action_id;
     translationList trans_list;
{
  deleteResult result;
  WidgetList instances;
  char errmsg[LINESIZE];

  extern char *local_dit;
  extern char username[];

  XBell(dpy, 40);

  result = get_delete_result(request_id);
  if (result->was_successful == TRUE)
    {
      setStatusMessage(object_id, "Entry deleted OK.");
      instances = findPrimitiveInstances(object_id, MODIFY);

      set_current_entry(object_id, local_dit);
      displayEntryTemplate(instances[0],
			   object_id,
			   MODIFY,
			   ActionUndefined,
			   NULLTransList);

      XtFree((char *) instances);
    }
  else
    /* Delete failed */
    {
      (void) sprintf(errmsg,
		     "Entry removal failed because:\n%s",
		     get_message_of_code(result->errors->error_type));

      setStatusMessage(object_id, errmsg);
    }

  set_current_errors(object_id, result->errors);
  result->errors = NULLError;

  request_complete(request_id);
  free_delete_result(&result);
} /* gotDeleteResult */
