#ifndef lint
static char *rcsid = "$Header: /a/pluto/vol/fileservers/Pluto/Pluto2/src/X500/xd/work/src/RCS/widgets.c,v 1.0 92/11/27 17:00:49 emsrdsm Exp Locker: emsrdsm $";
#endif

/* $Header: /a/pluto/vol/fileservers/Pluto/Pluto2/src/X500/xd/work/src/RCS/widgets.c,v 1.0 92/11/27 17:00:49 emsrdsm Exp Locker: emsrdsm $ */

/*****************************************************************************

  widgets.c - Widget creation functions.

*****************************************************************************/

#include "defs.h"
#include "windows.h"
#include "widgets.h"
#include "callbacks.h"
#include "configure.h"
#include "layout.h"
#include "actions.h"
#include "xutil.h"
#include "dn_list.h"
#include "sequence.h"
#include "y.tab.h"
#include "showlist.h"

#include "formsrch.h"
#include "update1.h"
#include "update2.h"

#include <X11/StringDefs.h>
#include <X11/cursorfont.h>
#include <X11/Xutil.h>
#include <X11/Shell.h>
 
#include <X11/Xaw/Cardinals.h>
#include <X11/Xaw/Viewport.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/SimpleMenu.h>
#include <X11/Xaw/Sme.h>
#include <X11/Xaw/SmeBSB.h>
#include <X11/Xaw/SmeLine.h>
#include <X11/Xaw/MenuButton.h>
#include <X11/Xaw/Dialog.h>
#include <X11/Xaw/List.h>

/***************************************************
 *
 * Externals.
 *
 */

extern Display *dpy;
extern objectAction actions[];

extern targetClass target_classes[];
extern QCardinal target_class_num;

/***************************************************
 *
 * Local declarations.
 *
 */

static void doNothing();
static Screen *screen;

static XtActionsRec action_table[] =
{
  {"doAction", (XtActionProc) callActionAsAction},
  {"doNothing", (XtActionProc) doNothing},
  {"doChangeFocus", (XtActionProc) doChangeFocus},
  {"doSetFocus", (XtActionProc) doSetFocus},
  {"getModifyFocus", (XtActionProc) getModifyFocus},
  {"changeModifyFocus", (XtActionProc) changeModifyFocus},
  {"changeDialogFocus", (XtActionProc) changeDialogFocus},
  {"setDialogFocus", (XtActionProc) setDialogFocus}
};

/***************************************************
 *
 * Global storage.
 *
 */

XContext action_cid, prim_type_cid, object_cid;

/* ARGSUSED */
static void doNothing(w, event, params, num_params)
     Widget w;
     XEvent *event;
     String *params;
     Cardinal num_params;
{
  ;
}

/*****************************************************************************
 * initWidgets()
 *
 * 
 *
 ****************************************************************************/

void initWidgets(app_context)
     XtAppContext app_context;
{
  extern Widget toplevel;

  XtAppAddActions(app_context, action_table, XtNumber(action_table));

  screen = XtScreen(toplevel);

  action_cid = XUniqueContext();
  object_cid = XUniqueContext();
  prim_type_cid = XUniqueContext();
} /* initWidgets */

/*****************************************************************************
 * makeButton()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
Widget makeButton(parent, object_id, template)
     Widget parent;
     Cardinal object_id;
     layoutMember template;
{
  Widget this_widget;
  Arg args[MAXARGS];
  Cardinal count;
  Cursor hand_cursor = XCreateFontCursor(dpy, XC_hand2);
  int  width, height;
  String name = template->name;

  count = 0;
  if (template->bitmap_file != NULLString)
    {
      if (get_dims_of_bitmap_file(template->bitmap_file, &width, &height)
	  == TRUE)
	{
	  XtSetArg(args[count], XtNwidth, (Dimension) width); count++;
	  XtSetArg(args[count], XtNheight, (Dimension) height); count++;
	  XtSetArg(args[count], XtNlabel, ""); count++;
	}
    }
  else
    {
      if (template->height != 0)
	{
	  XtSetArg(args[count], XtNheight, template->height); count++;
	}
      
      if (template->width != 0)
	{
	  XtSetArg(args[count], XtNwidth, template->width); count++;
	}

      if (template->label != NULLString)
	{
	  XtSetArg(args[count], XtNlabel, template->label); count++;
	}
    }

  XtSetArg(args[count], XtNresizable, FALSE); count++;
  XtSetArg(args[count], XtNcursor, hand_cursor); count++;

  this_widget = XtCreateManagedWidget((name == NULLString? "button" : name),
				      commandWidgetClass,
				      parent,
				      args,
				      count);

  return this_widget;
} /* makeButton */

/*****************************************************************************
 * makeMoveto()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
Widget makeMoveto(parent, object_id, template)
     Widget parent;
     Cardinal object_id;
     layoutMember template;
{
  Arg args[MAXARGS];
  Cardinal count;
  Widget this_widget, label, dialog;
  Dimension height;
  Cursor question_cur = XCreateFontCursor(dpy, XC_question_arrow);

  count = 0;
  XtSetArg(args[count], XtNresizable, TRUE); count++;

  if (template->height != 0)
    {
      XtSetArg(args[count], XtNheight, template->height); count++;
    }

  if (template->width != 0)
    {
      XtSetArg(args[count], XtNwidth, template->width); count++;
    }

  XtSetArg(args[count], XtNcursor, question_cur); count++;
  this_widget = XtCreateManagedWidget("moveto",
				      formWidgetClass,
				      parent,
				      args,
				      count);

  count = 0;

  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainLeft); count++;

  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;

  label = XtCreateManagedWidget("movetoLabel",
				labelWidgetClass,
				this_widget,
				args,
				count);

  count = 0;

  XtSetArg(args[count], XtNfromHoriz, label); count++;
  XtSetArg(args[count], XtNeditType, XawtextEdit); count++;

  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainRight); count++;  

  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;

  XtSetArg(args[count], XtNscrollHorizontal, XawtextScrollNever); count++;
  XtSetArg(args[count], XtNscrollVertical, XawtextScrollNever); count++;

  dialog = XtCreateManagedWidget("movetoDialog",
				 asciiTextWidgetClass,
				 this_widget,
				 args,
				 count);

  XtSetKeyboardFocus(this_widget, dialog);

  /***************************************************
   *
   * The dialog box has an auto-scrollbar,
   * so need to adjust the height of
   * the dialog box to allow for this.
   *
   */

  count = 0;
  XtSetArg(args[count], XtNheight, &height); count++;
  XtGetValues(dialog, args, count);

  height += 4;

  count = 0;
  XtSetArg(args[count], XtNheight, height); count++;
  XtSetValues(dialog, args, count);

  return this_widget;
} /* makeMoveto */

/*****************************************************************************
 * makeStatusLabel()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
Widget makeStatusLabel(parent, object_id, template)
     Widget parent;
     Cardinal object_id;
     layoutMember template;
{
  Arg args[MAXARGS];
  Cardinal count;
  Widget this_widget;

  count = 0;
  XtSetArg(args[count], XtNresizable, TRUE); count++;

  if (template->height != 0)
    {
      XtSetArg(args[count], XtNheight, template->height); count++;
    }

  if (template->width != 0)
    {
      XtSetArg(args[count], XtNwidth, template->width); count++;
    }

  XtSetArg(args[count], XtNresize, FALSE); count++;
  XtSetArg(args[count], XtNlabel, ""); count++;

  this_widget = XtCreateManagedWidget("statusBar",
				      labelWidgetClass,
				      parent,
				      args,
				      count);

  return this_widget;
} /* makeStatusLabel */

/*****************************************************************************
 * makeTitleBar()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
Widget makeTitleBar(parent, object_id, template)
     Widget parent;
     Cardinal object_id;
     layoutMember template;
{
  Arg args[MAXARGS];
  Cardinal count;
  Widget this_widget;
  String name = template->name;
  int width, height;

  count = 0;
  XtSetArg(args[count], XtNresizable, TRUE); count++;

  if (template->bitmap_file != NULLString)
    {
      if (get_dims_of_bitmap_file(template->bitmap_file,&width,&height) ==TRUE)
	{
	  XtSetArg(args[count], XtNwidth, width); count++;
	  XtSetArg(args[count], XtNheight, height); count++;
	  XtSetArg(args[count], XtNlabel, ""); count++;
	}
    }
  else
    {
      if (template->height != 0)
	{
	  XtSetArg(args[count], XtNheight, template->height); count++;
	}
      
      if (template->width != 0)
	{
	  XtSetArg(args[count], XtNwidth, template->width); count++;
	}

      if (template->label != NULLString)
	{
	  XtSetArg(args[count], XtNlabel, template->label); count++;
	}
    }

  XtSetArg(args[count], XtNresize, FALSE); count++;
  XtSetArg(args[count], XtNborderWidth, 0); count++;

  this_widget = XtCreateManagedWidget((name == NULLString? "titleBar" : name),
				      labelWidgetClass,
				      parent,
				      args,
				      count);

  return this_widget;
} /* makeTitleBar */

/*****************************************************************************
 * makeReadDisplay()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
Widget makeReadDisplay(parent, object_id, template)
     Widget parent;
     Cardinal object_id;
     layoutMember template;
{
  Arg args[MAXARGS];
  Cardinal count;
  Widget this_widget;
  Widget types, values, form, hscroll, vscroll, name, select_button;

  count = 0;

  XtSetArg(args[count], XtNresize, TRUE); count++;
  XtSetArg(args[count], XtNresizable, FALSE); count++;

  if (template->height != 0)
    {
      XtSetArg(args[count], XtNheight, template->height); count++;
    }

  if (template->width != 0)
    {
      XtSetArg(args[count], XtNwidth, template->width); count++;
    }

  XtSetArg(args[count], XtNallowHoriz, TRUE); count++;
  XtSetArg(args[count], XtNallowVert, TRUE); count++;

  XtSetArg(args[count], XtNuseRight, TRUE); count++;
  XtSetArg(args[count], XtNuseBottom, TRUE); count++;

  XtSetArg(args[count], XtNforceBars, TRUE); count++;
  this_widget = XtCreateManagedWidget("readDisplay",
				      viewportWidgetClass,
				      parent,
				      args,
				      count);

  count = 0;

  XtSetArg(args[count], XtNresizable, TRUE); count++;
  XtSetArg(args[count], XtNresize, TRUE); count++;
  XtSetArg(args[count], XtNdefaultDistance, 8); count++;

  form = XtCreateManagedWidget("readForm",
			       formWidgetClass,
			       this_widget,
			       args,
			       count);

  count = 0;

  XtSetArg(args[count], XtNresizable, TRUE); count++;
  XtSetArg(args[count], XtNlabel, ""); count++;
  
  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainLeft); count++;

  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;

  name = XtCreateManagedWidget("entryName",
			       labelWidgetClass,
			       form,
			       args,
			       count);

  count = 0;
  XtSetArg(args[count], XtNfromVert, name); count++;

  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainLeft); count++;

  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;

  select_button = XtCreateManagedWidget("selectForMUA",
					commandWidgetClass,
					form,
					args,
					count);

  count = 0;
  XtSetArg(args[count], XtNborderWidth, 0); count++;

  XtSetArg(args[count], XtNeditType, XawtextRead); count++;
  XtSetArg(args[count], XtNstring, ""); count++;

  XtSetArg(args[count], XtNresizable, TRUE); count++;
  XtSetArg(args[count], XtNresize, XawtextResizeBoth); count++;

  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainLeft); count++;

  XtSetArg(args[count], XtNtop, XtChainTop); count++;
/*   XtSetArg(args[count], XtNbottom, XtChainTop); count++; */

  XtSetArg(args[count], XtNdisplayCaret, FALSE); count++;
  XtSetArg(args[count], XtNfromVert, select_button); count++;

  types = XtCreateManagedWidget("readTypes",
                                asciiTextWidgetClass,
				form,
				args,
				count);

  count = 0;
  XtSetArg(args[count], XtNborderWidth, 0); count++;

  XtSetArg(args[count], XtNeditType, XawtextRead); count++;
  XtSetArg(args[count], XtNstring, ""); count++;

  XtSetArg(args[count], XtNresizable, TRUE); count++;
  XtSetArg(args[count], XtNresize, XawtextResizeBoth); count++;

  XtSetArg(args[count], XtNfromHoriz, types); count++;
  XtSetArg(args[count], XtNfromVert, select_button); count++;

  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainLeft); count++;

  XtSetArg(args[count], XtNtop, XtChainTop); count++;
/*   XtSetArg(args[count], XtNbottom, XtChainTop); count++; */

  XtSetArg(args[count], XtNdisplayCaret, FALSE); count++;
  XtSetArg(args[count], XtNhorizDistance, 8); count++;

  values = XtCreateManagedWidget("readValues",
				 asciiTextWidgetClass,
				 form,
				 args,
				 count);

  count = 0;

  XtSetArg(args[count], XtNlabel, " "); count++;
  XtSetArg(args[count], XtNresizable, TRUE); count++;

  XtSetArg(args[count], XtNfromHoriz, values); count++;
  XtSetArg(args[count], XtNfromVert, name); count++;

  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainLeft); count++;

  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;

  XtSetArg(args[count], XtNvertDistance, 12); count++;
  XtSetArg(args[count], XtNhorizDistance, 8); count++;

  (void) XtCreateManagedWidget("photo",
			       labelWidgetClass,
			       form,
			       args,
			       count);

  /***************************************************
   *
   * Set dimensions of scrollbars.
   *
   */

  vscroll = XtNameToWidget(this_widget, "vertical");
  if (vscroll != NULLWidget)
    {
      count = 0;
      XtSetArg(args[count], XtNresize, TRUE); count++;
      XtSetArg(args[count], XtNwidth, (Dimension) 9); count++;
      XtSetValues(vscroll, args, count);
    }

  hscroll = XtNameToWidget(this_widget, "horizontal");
  if (hscroll != NULLWidget)
    {
      count = 0;
      XtSetArg(args[count], XtNresize, TRUE); count++;
      XtSetArg(args[count], XtNheight, (Dimension) 9); count++;
      XtSetValues(hscroll, args, count);
    }

  return this_widget;
} /* makeReadDisplay */

/*****************************************************************************
 * makeSearchGroup()
 *
 * 
 *
 ****************************************************************************/

Widget makeSearchGroup(parent, object_id, template)
     Widget parent;
     Cardinal object_id;
     layoutMember template;
{
  Arg args[MAXARGS];
  Cardinal count, cindex;
  Widget this_widget, menu_button, menu_shell, menuitem, topmenuitem;
  primInfo prim_data;
  primActionList action_list = template->action_list;

  /* Create parent form */
  count = 0;

  XtSetArg(args[count], XtNdefaultDistance, 16); count++;

  if (template->height != 0)
    {
      XtSetArg(args[count], XtNheight, template->height); count++;
    }

  if (template->width != 0)
    {
      XtSetArg(args[count], XtNwidth, template->width); count++;
    }

  this_widget = XtCreateManagedWidget("searchGroup",
				      formWidgetClass,
				      parent,
				      args,
				      count);

  /***************************************************
   *
   * Create type menu button.
   *
   */
  
  count = 0;
  XtSetArg(args[count], XtNlabel, "Search for..."); count++;

  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;

  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainLeft); count++;

  XtSetArg(args[count], XtNresizable, TRUE); count++;
  menu_button = XtCreateManagedWidget("typeButton",
				      menuButtonWidgetClass,
				      this_widget,
				      args,
				      count);

 /***************************************************
  *
  * Create menu shell.
  *
  */

  count = 0;
  menu_shell = XtCreatePopupShell("menu",
				  simpleMenuWidgetClass,
				  menu_button,
				  args,
				  0); 

  /***************************************************
   *
   * Keep data for changes in search type.
   *
   */

  prim_data = prim_info_alloc();
  prim_data->object_id = object_id;

  if (action_list != (primActionList) NULL)
    prim_data->action_id = action_list->prim_action_id;
  else
    prim_data->action_id = ActionUndefined;

  prim_data->primitive_id = LOOKUP;

  /***************************************************
   *
   * Create menu buttons.
   *
   */

  topmenuitem = NULLWidget;

  for (cindex = 0; cindex < target_class_num; cindex++)
    {
      /***************************************************
       *
       * Create menu item corresponding to a search type.
       *
       */

      count = 0;
      XtSetArg(args[count], XtNlabel, target_classes[cindex]->target_label);
      menuitem = XtCreateManagedWidget(target_classes[cindex]->target_label,
				       smeBSBObjectClass,
				       menu_shell,
				       args,
				       count);

      if (topmenuitem == NULLWidget)
	topmenuitem = menuitem;
      
      XtAddCallback(menuitem,
		    XtNcallback,
		    changeUfsType,
		    (XtPointer) prim_data);
    }

  XtAddCallback(menu_shell,
		XtNdestroyCallback,
		FreePrimInfo,
		(XtPointer) prim_data);

  /***************************************************
   *
   * Create label containing name of
   * current search attribute.
   *
   */

  count = 0;
  XtSetArg(args[count], XtNresizable, TRUE); count++;

  XtSetArg(args[count], XtNlabel, "Person"); count++;
  XtSetArg(args[count], XtNfromHoriz, menu_button); count++;

  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;

  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainLeft); count++;

  (void) XtCreateManagedWidget ("searchTypeLabel",
				labelWidgetClass,
				this_widget,
				args,
				count);

  /***************************************************
   *
   * Create the search edit fields.
   *
   */

  searchForType(topmenuitem, (WidgetList) NULL);
  count = 0;

  if (template->height != 0)
    {
      XtSetArg(args[count], XtNheight, template->height); count++;
    }

  if (template->width != 0)
    {
      XtSetArg(args[count], XtNwidth, template->width); count++;
    }

  XtSetValues(this_widget, args, count);
  XawFormDoLayout(this_widget, TRUE);

  return this_widget;
} /* makeSearchGroup */

/*****************************************************************************
 * makeListDisplay()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
Widget makeListDisplay(parent, object_id, template)
     Widget parent;
     Cardinal object_id;
     layoutMember template;
{
  Arg args[MAXARGS];
  Cardinal count;
  Widget this_widget, vscroll, hscroll;
  String null_list[1];

  null_list[0] = NULLString;
  
  count = 0;

  XtSetArg(args[count], XtNresize, TRUE); count++;
  XtSetArg(args[count], XtNresizable, TRUE); count++;

  if (template->height != 0)
    {
      XtSetArg(args[count], XtNheight, template->height); count++;
    }

  if (template->width != 0)
    {
      XtSetArg(args[count], XtNwidth, template->width); count++;
    }

  XtSetArg(args[count], XtNallowHoriz, TRUE); count++;
  XtSetArg(args[count], XtNallowVert, TRUE); count++;

  XtSetArg(args[count], XtNuseRight, TRUE); count++;
  XtSetArg(args[count], XtNuseBottom, TRUE); count++;

  XtSetArg(args[count], XtNforceBars, TRUE); count++;
  this_widget = XtCreateManagedWidget("listDisplay",
                                      viewportWidgetClass,
                                      parent,
                                      args,
                                      count);
  count = 0;

  XtSetArg(args[count], XtNresizable, TRUE); count++;
  XtSetArg(args[count], XtNborderWidth, 0); count++;

  XtSetArg(args[count], XtNlist, null_list); count++;
  XtSetArg(args[count], XtNrowSpacing, 4); count++;

  XtSetArg(args[count], XtNinternalHeight, 4); count++;
  XtSetArg(args[count], XtNinternalWidth, 6); count++;
   
  XtSetArg(args[count], XtNdefaultColumns, 1); count++;
  XtSetArg(args[count], XtNforceColumns, TRUE); count++;

  (void) XtCreateManagedWidget("listForm",
			       listWidgetClass,
			       this_widget,
			       args,
			       count);

  /***************************************************
   *
   * Set dimensions of scrollbars.
   *
   */

  vscroll = XtNameToWidget(this_widget, "vertical");

  if (vscroll != NULLWidget)
    {
      count = 0;
      XtSetArg(args[count], XtNresize, TRUE); count++;
      XtSetArg(args[count], XtNwidth, 9); count++;
      XtSetValues(vscroll, args, count);
    }

  hscroll = XtNameToWidget(this_widget, "horizontal");

  if (hscroll != NULLWidget)
    {
      count = 0;
      XtSetArg(args[count], XtNresize, TRUE); count++;
      XtSetArg(args[count], XtNheight, 9); count++;
      XtSetValues(hscroll, args, count);
    }

  return this_widget;
} /* makeListDisplay */

/*****************************************************************************
 * makeHelpDisplay()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
Widget makeHelpDisplay(parent, object_id, template)
     Widget parent;
     Cardinal object_id;
     layoutMember template;
{
  Arg args[MAXARGS];
  Cardinal count;
  Widget this_widget, form, help_text, vscroll, hscroll;

  count = 0;

  XtSetArg(args[count], XtNresize, TRUE); count++;
  XtSetArg(args[count], XtNresizable, FALSE); count++;

  if (template->height != 0)
    {
      XtSetArg(args[count], XtNheight, template->height); count++;
    }

  if (template->width != 0)
    {
      XtSetArg(args[count], XtNwidth, template->width); count++;
    }

  XtSetArg(args[count], XtNallowHoriz, TRUE); count++;
  XtSetArg(args[count], XtNallowVert, TRUE); count++;

  XtSetArg(args[count], XtNforceBars, TRUE); count++;
  XtSetArg(args[count], XtNuseRight, TRUE); count++;

  XtSetArg(args[count], XtNuseBottom, TRUE); count++;

  this_widget = XtCreateManagedWidget("helpDisplay",
				      viewportWidgetClass,
				      parent,
				      args,
				      count);


  count = 0;

  XtSetArg(args[count], XtNresizable, TRUE); count++;
  XtSetArg(args[count], XtNresize, TRUE); count++;

  form = XtCreateManagedWidget("helpViewForm",
			       formWidgetClass,
			       this_widget,
			       args,
			       count);
  

  count = 0;

  XtSetArg(args[count], XtNstring, ""); count++;
  XtSetArg(args[count], XtNeditType, XawtextRead); count++;

  XtSetArg(args[count], XtNdisplayCaret, FALSE); count++;
  XtSetArg(args[count], XtNborderWidth, 0); count++;

  XtSetArg(args[count], XtNresize, XawtextResizeBoth); count++;
  XtSetArg(args[count], XtNresizable, TRUE); count++;

  XtSetArg(args[count], XtNbottom, XtChainTop); count++;
  XtSetArg(args[count], XtNtop, XtChainTop); count++;

  XtSetArg(args[count], XtNright, XtChainLeft); count++;
  XtSetArg(args[count], XtNleft, XtChainLeft); count++;

  help_text = XtCreateManagedWidget("helpText",
				    asciiTextWidgetClass,
				    form,
				    args,
				    count);

  count = 0;
  
  XtSetArg(args[count], XtNfromHoriz, help_text); count++;
  XtSetArg(args[count], XtNresizable, TRUE); count++;

  XtSetArg(args[count], XtNlabel, ""); count++;
  XtSetArg(args[count], XtNborder, 0); count++;
  
  XtSetArg(args[count], XtNright, XtChainLeft); count++;
  XtSetArg(args[count], XtNleft, XtChainLeft); count++;

  XtSetArg(args[count], XtNbottom, XtChainTop); count++;
  XtSetArg(args[count], XtNtop, XtChainTop); count++;

  (void) XtCreateManagedWidget("helpBitmap",
			       labelWidgetClass,
			       form,
			       args,
			       count);
  
  /***************************************************
   *
   * Set dimensions of scrollbars.
   *
   */

  vscroll = XtNameToWidget(this_widget, "vertical");

  if (vscroll != NULLWidget)
    {
      count = 0;
      XtSetArg(args[count], XtNresize, TRUE); count++;
      XtSetArg(args[count], XtNwidth, 8); count++;

      XtSetValues(vscroll, args, count);
    }

  hscroll = XtNameToWidget(this_widget, "horizontal");

  if (hscroll != NULLWidget)
    {
      count = 0;
      XtSetArg(args[count], XtNresize, TRUE); count++;
      XtSetArg(args[count], XtNheight, 8); count++;

      XtSetValues(hscroll, args, count);
    }

  return this_widget;
} /* makeHelpDisplay */

/*****************************************************************************
 * makeModifyWindow()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
Widget makeModifyWindow(parent,	object_id, template)
     Widget parent;
     Cardinal object_id;
     layoutMember template;
{
  Arg args[MAXARGS];
  Cardinal count;

  Widget this_widget, modify_view;
  Widget hscroll, vscroll, entry_label, entry_name;
  Widget commit_button, add_button, delete_button;
  Widget group_button, group_label, group_info_label, previous, next;

  int height, width, default_distance = 14;
  Dimension tmp_width;
  Cursor hand_cursor = XCreateFontCursor(dpy, XC_hand2);

  extern void submitModificationsCallbacks(),
              addEntryCallback(),
              deleteEntryCallback();

  extern XContext mod_status_cid;

  /***************************************************
   *
   * The top level form.
   *
   */

  count = 0;

  XtSetArg(args[count], XtNresizable, TRUE); count++;
  XtSetArg(args[count], XtNdefaultDistance, default_distance); count++;

  this_widget = XtCreateManagedWidget("modifyForm",
				      formWidgetClass,
				      parent,
				      args,
				      count);

  

  /***************************************************
   *
   * Commit updates button.
   *
   */

  count = 0;

  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainLeft); count++;

  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;

  XtSetArg(args[count], XtNcursor, hand_cursor); count++;
  commit_button = XtCreateManagedWidget("commitModificationsButton",
					commandWidgetClass,
					this_widget,
					args,
					count);

  XtAddCallback(commit_button,
		XtNcallback,
		submitModificationsCallback,
		(XtPointer) this_widget);

  XtSetSensitive(commit_button, FALSE);

  /***************************************************
   *
   * The add entry button.
   *
   */

  count = 0;

  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainLeft); count++;

  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;

  XtSetArg(args[count], XtNfromHoriz, commit_button); count++;
  XtSetArg(args[count], XtNcursor, hand_cursor); count++;

  add_button = XtCreateManagedWidget("addEntryButton",
				     commandWidgetClass,
				     this_widget,
				     args,
				     count);

  XtAddCallback(add_button,
		XtNcallback,
		addDialog,
		(XtPointer) this_widget);

  /***************************************************
   *
   * The delete entry button.
   *
   */

  count = 0;

  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainLeft); count++;

  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;

  XtSetArg(args[count], XtNfromHoriz, add_button); count++;
  XtSetArg(args[count], XtNcursor, hand_cursor); count++;

  delete_button = XtCreateManagedWidget("deleteEntryButton",
					commandWidgetClass,
					this_widget,
					args,
					count);

  XtAddCallback(delete_button,
		XtNcallback,
		deleteEntry,
		(XtPointer) this_widget);

  /***************************************************
   *
   * Label.
   *
   */

  count = 0;
  
  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainLeft); count++;

  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;

  XtSetArg(args[count], XtNfromVert, delete_button); count++;
  XtSetArg(args[count], XtNvertDistance, default_distance + 4); count++;
  
  entry_label = XtCreateManagedWidget("entryLabel",
				      labelWidgetClass,
				      this_widget,
				      args,
				      count);

  /***************************************************
   *
   * Entry name label.
   *
   */

  count = 0;

  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainRight); count++;

  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;

  XtSetArg(args[count], XtNfromVert, delete_button); count++;
  XtSetArg(args[count], XtNfromHoriz, entry_label); count++;

  XtSetArg(args[count], XtNscrollHorizontal, XawtextScrollNever); count++;
  XtSetArg(args[count], XtNeditType, XawtextRead); count++;

  XtSetArg(args[count], XtNvertDistance, default_distance + 4); count++;
  XtSetArg(args[count], XtNdisplayCaret, FALSE); count++;

  entry_name = XtCreateManagedWidget("entryName",
				     asciiTextWidgetClass,
				     this_widget,
				     args,
				     count);

  /***************************************************
   *
   * Make sure that the edit field fills
   * out as much width as possible.
   */

  count = 0;
  XtSetArg(args[count], XtNwidth, &tmp_width); count++;
  XtGetValues(entry_label, args, count);

  count = 0;

  if (template->width != 0)
    {
      width = template->width - (default_distance * 3) - tmp_width;
      XtSetArg(args[count], XtNwidth, (Dimension) width); count++;
    }

  XtSetValues(entry_name, args, count);

  /***************************************************
   *
   * Attribute group stuff.
   *
   */

  count = 0;
  
  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainLeft); count++;

  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;

  XtSetArg(args[count], XtNfromVert, entry_name); count++;
  XtSetArg(args[count], XtNvertDistance, default_distance + 4); count++;

  group_label = XtCreateManagedWidget("groupLabel",
				      labelWidgetClass,
				      this_widget,
				      args,
				      count);
  
  count = 0;
  
  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainRight); count++;

  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;

  XtSetArg(args[count], XtNresizable, TRUE); count++;

  XtSetArg(args[count], XtNfromVert, entry_name); count++;
  XtSetArg(args[count], XtNfromHoriz, group_label); count++;

  XtSetArg(args[count], XtNvertDistance, default_distance + 4); count++;
  XtSetArg(args[count], XtNlabel, ""); count++;
  
  group_info_label = XtCreateManagedWidget("groupInfoLabel",
					   labelWidgetClass,
					   this_widget,
					   args,
					   count);

  /***************************************************
   *
   * Make sure that the info field
   * fills out as much width as possible.
   *
   */

  count = 0;
  XtSetArg(args[count], XtNwidth, &tmp_width); count++;
  XtGetValues(group_label, args, count);

  count = 0;

  if (template->width != 0)
    {
      width = template->width - (default_distance * 3) - tmp_width;
      XtSetArg(args[count], XtNwidth, (Dimension) width); count++;
    }

  XtSetValues(group_info_label, args, count);

  /***************************************************
   *
   * Group selection stuff.
   *
   */

  count = 0;

  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainLeft); count++;

  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;

  XtSetArg(args[count], XtNfromVert, group_info_label); count++;
  XtSetArg(args[count], XtNresizable, TRUE); count++;

  group_button = XtCreateManagedWidget("groupButton",
				       menuButtonWidgetClass,
				       this_widget,
				       args,
				       count);

   (void) XtCreatePopupShell("menu",
			     simpleMenuWidgetClass,
			     group_button,
			     args,
			     0);
  
  count = 0;

  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainLeft); count++;

  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;

  XtSetArg(args[count], XtNfromVert, group_info_label); count++;
  XtSetArg(args[count], XtNfromHoriz, group_button); count++;

  previous = XtCreateManagedWidget("previousGroup",
				   commandWidgetClass,
				   this_widget,
				   args,
				   count);

  XtAddCallback(previous,
		XtNcallback,
		displayPreviousGroup,
		(XtPointer) NULL);


  count = 0;

  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainLeft); count++;

  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;

  XtSetArg(args[count], XtNfromVert, group_info_label); count++;
  XtSetArg(args[count], XtNfromHoriz, previous); count++;

  next = XtCreateManagedWidget("nextGroup",
			       commandWidgetClass,
			       this_widget,
			       args,
			       count);

  XtAddCallback(next,
		XtNcallback,
		displayNextGroup,
		(XtPointer) NULL);

  /***************************************************
   *
   * Viewport for attribute edit form pages.
   *
   */

  count = 0;

  XtSetArg(args[count], XtNfromVert, next); count++;

  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainRight); count++;

  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainBottom); count++;

  XtSetArg(args[count], XtNallowHoriz, TRUE); count++;
  XtSetArg(args[count], XtNallowVert, TRUE); count++;

  XtSetArg(args[count], XtNuseRight, TRUE); count++;
  XtSetArg(args[count], XtNuseBottom, TRUE); count++;

  XtSetArg(args[count], XtNforceBars, TRUE); count++;

  if (template->height != 0)
    {
      height = template->height - (default_distance * 3);
      XtSetArg(args[count], XtNheight, (Dimension) height); count++;
    }

  if (template->width != 0)
    {
      width = template->width - (default_distance * 2);
      XtSetArg(args[count], XtNwidth, (Dimension) width); count++;
    }

  modify_view = XtCreateManagedWidget("modifyWindow",
				      viewportWidgetClass,
				      this_widget,
				      args,
				      count);

  /***************************************************
   *
   * Top level form in viewport,
   * individual edit fields/dialogs will be
   * contained in sub forms.
   *
   */

  count = 0;

  XtSetArg(args[count], XtNresizable, TRUE); count++;
  XtSetArg(args[count], XtNdefaultDistance, 0); count++;

  (void) XtCreateManagedWidget("modifyViewForm",
			       formWidgetClass,
			       modify_view,
			       args,
			       count);

  /***************************************************
   *
   * Set dimensions for viewport scrollbars.
   *
   */

  vscroll = XtNameToWidget(modify_view, "vertical");
  if (vscroll != NULLWidget)
    {
      count = 0;

      XtSetArg(args[count], XtNresize, TRUE); count++;
      XtSetArg(args[count], XtNwidth, (Dimension) 9); count++;

      XtSetValues(vscroll, args, count);
    }

  hscroll = XtNameToWidget(modify_view, "horizontal");
  if (hscroll != NULLWidget)
    {
      count = 0;

      XtSetArg(args[count], XtNresize, TRUE); count++;
      XtSetArg(args[count], XtNheight, (Dimension) 9); count++;

      XtSetValues(hscroll, args, count);
    }

  return this_widget;
} /* makeModifyWindow */

/*****************************************************************************
 * makeErrorViewer()
 *
 * 
 *
 ****************************************************************************/

/* ARGSUSED */
Widget makeErrorViewer(parent, object_id, template)
     Widget parent;
     Cardinal object_id;
     layoutMember template;
{
  Arg args[MAXARGS];
  Cardinal count;
  Widget this_widget, view_form, hscroll, vscroll;

  count = 0;

  XtSetArg(args[count], XtNallowHoriz, TRUE); count++;
  XtSetArg(args[count], XtNallowVert, TRUE); count++;

  XtSetArg(args[count], XtNuseRight, TRUE); count++;
  XtSetArg(args[count], XtNuseBottom, TRUE); count++;

  XtSetArg(args[count], XtNresizable, TRUE); count++;
  XtSetArg(args[count], XtNforceBars, TRUE); count++;

  if (template->height != 0)
    {
      XtSetArg(args[count], XtNheight, template->height); count++;
    }

  if (template->width != 0)
    {
      XtSetArg(args[count], XtNwidth, template->width); count++;
    }

  this_widget = XtCreateManagedWidget("errorWindow",
				      viewportWidgetClass,
				      parent,
				      args,
				      count);

  count = 0;

  XtSetArg(args[count], XtNresizable, TRUE); count++;
  XtSetArg(args[count], XtNdefaultDistance, 14); count++;

  view_form = XtCreateManagedWidget("errorViewForm",
				    formWidgetClass,
				    this_widget,
				    args,
				    count);

  count = 0;
  
  XtSetArg(args[count], XtNborderWidth, 0); count++;

  XtSetArg(args[count], XtNresizable, TRUE); count++;
  XtSetArg(args[count], XtNlabel, "No Errors"); count++;

  XtSetArg(args[count], XtNleft, XtChainLeft); count++;
  XtSetArg(args[count], XtNright, XtChainRight); count++;

  XtSetArg(args[count], XtNtop, XtChainTop); count++;
  XtSetArg(args[count], XtNbottom, XtChainTop); count++;

  (void) XtCreateManagedWidget("errorViewLabel",
			       labelWidgetClass,
			       view_form,
			       args,
			       count);

  /***************************************************
   *
   * Set scrollbar dimensions.
   *
   */

  vscroll = XtNameToWidget(this_widget, "vertical");
  if (vscroll != NULLWidget)
    {
      count = 0;

      XtSetArg(args[count], XtNresize, TRUE); count++;
      XtSetArg(args[count], XtNwidth, (Dimension) 9); count++;

      XtSetValues(vscroll, args, count);
    }

  hscroll = XtNameToWidget(this_widget, "horizontal");
  if (hscroll != NULLWidget)
    {
      count = 0;

      XtSetArg(args[count], XtNresize, TRUE); count++;
      XtSetArg(args[count], XtNheight, (Dimension) 9); count++;

      XtSetValues(hscroll, args, count);
    }

  return this_widget;
} /* makeErrorViewer */
