/*****************************************************************************

  widgets.h - Declarations for widget/part  creation functions.

*****************************************************************************/

#ifndef _Xlu_widgets_h
#define _Xlu_widgets_h

#include "windows.h"
#include "defs.h"
#include "actions.h"

typedef struct _prim_info
{
  Cardinal primitive_id;
  Cardinal object_id;
  actionID action_id;
} prim_info, *primInfo;

#define NULLPrimInfo (primInfo) NULL
#define prim_info_alloc() (primInfo) XtMalloc(sizeof(prim_info))

/*
 *	Global functions..
 */

void initWidgets();

Widget makeButton();
Widget makeMoveto();
Widget makeStatusLabel();
Widget makeTitleBar();
Widget makeReadDisplay();
Widget makeSearchGroup();
Widget makeListDisplay();
Widget makeHelpDisplay();
Widget makeModifyWindow();
Widget makeErrorViewer();

#endif /* _Xlu_widgets_h */


