#ifndef lint
static char *rcsid = "$Header: /a/pluto/vol/fileservers/Pluto/Pluto2/src/X500/xd/work/src/RCS/xdutil.c,v 1.0 92/11/27 17:00:55 emsrdsm Exp Locker: emsrdsm $";
#endif

/* $Header: /a/pluto/vol/fileservers/Pluto/Pluto2/src/X500/xd/work/src/RCS/xdutil.c,v 1.0 92/11/27 17:00:55 emsrdsm Exp Locker: emsrdsm $ */

/*****************************************************************************

  xdutil.c - Assorted procedures

*****************************************************************************/

#include "xdutil.h"
#include "defs.h"
#include "quipu/attr.h"
#include "configure.h"

/***************************************************
 *
 * Global storage.
 *
 */

attributeName attr_name_list = NULLAttributeName;

/*****************************************************************************
 * getAttributeName()
 *
 * Get "friendly" attribute name.
 *
 ****************************************************************************/

String getAttributeName(attr_type)
     AttributeType attr_type;
{
  register attributeName names;
  
  for (names = attr_name_list;
       names != NULLAttributeName && names->type != attr_type;
       names = names->next)
    ;

  if (names != NULLAttributeName && names->name != NULLString)
    return names->name;

  return attr2name(attr_type, OIDPART);
}

/*****************************************************************************
 * getAttributeOfName()
 *
 * Get an AttributeType keyed with it's "friendly" name.
 *
 ****************************************************************************/

AttributeType getAttributeOfName(name)
     String name;
{
  register attributeName names;
  
  for (names = attr_name_list;
       names != NULLAttributeName && lexequ(names->name, name) != 0;
       names = names->next)
    ;

  if (names != NULLAttributeName && names->name != NULLString)
    return names->type;

  return AttrT_new(name);
} /* getAttributeOfName */

/*****************************************************************************
 * xluWarning()
 *
 *  
 *
 ****************************************************************************/

void xluWarning(msg)
     String msg;
{
  char err_msg[LINESIZE];

  (void) sprintf(err_msg, "Error : %s\n", msg);
  (void) fprintf(stderr, "%s", err_msg);
} /* xluWarning */

/*****************************************************************************
 * xluFatal()
 *
 * 
 *
 ****************************************************************************/

void xluFatal(error)
     String error;
{
  char err_msg[LINESIZE];
  extern void exit();

  (void) sprintf(err_msg, "Fatal error : %s\n", error);
  (void) fprintf(stderr, "%s", err_msg);

  exit(1);
} /* xluFatal */
